﻿<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ryby</title>
  <link rel="stylesheet" href="https://stackedit.io/style.css" />
</head>

<body class="stackedit">
  <div class="stackedit__html"><h1 id="ryby">Ryby</h1>
<h2 id="popis-algoritmu">Popis algoritmu</h2>
<p>Algoritmus nejprve spočítá obecnou rovnici přímky podle dané směrnice,<br>
kterou převede na normálový vektor přímky, a bodu <code>[0,0]</code> (Mohl by být jakýkoliv bod).<br>
Vychází ze vzorce <code>V = (a*x + b*y + c) / sqrt(a^2 + b^2)</code> kde <em>a</em>, <em>b</em> a <em>c</em> vychází z obecné rovnice přímky a <em>x</em> a <em>y</em> jsou souřadnice bodu.<br>
Jelikož bod je <code>[0,0]</code> =&gt; <em>c</em>=0, a <em>a</em> a <em>b</em> se nemění - díky tomu zůstává jmenovatel v případě všech vrcholů stejný - můžeme vzorec zjednodušit:<br>
<code>V = a*x + b*y</code>.<br>
Tím se zároveň eliminuje problém s čísly s desetinnou čístí (float, double) a jejich nepřesnostmi.</p>
<p>Poté načítá vrcholy polygonů, přičemž vždy spočítá jeho vzdálenost od této přímky<br>
(vzdálenost není v absolutní hodnotě - vrcholy na jedné straně přímky budou mít kladnou vzdálenost, vrcholy na opačné straně přímky zápornou)<br>
a pro každý polygon uchovává “začátek” a “konec” tohoto polygonu.<br>
“Začátek” a “konec” jsou dva od sebe nejvzdálenější vrcholy ve směru kolmém na přímku.<br>
(“Začátek” má nejmenší hodnotu vypočítané vzdálenost, “konec” největší)</p>
<p>Po zpracování každého se tyto dva vrcholy přidají do pole vrcholů,<br>
první z nich se označí jako začátek.</p>
<p>Všechny vrcholy ve vytvořeném poli se seřadí podle vzdálenosti od přímky.<br>
Pokud mají shodnou vzdálenost, prioritu má ten, který je “začínající”.<br>
Díky tomu při následném procházení se nejdřív připočtou okraje následujících “začínajících” polygonů<br>
a až poté se odečtou předchozí “končící” polygony.</p>
<p>Vytvoří proměné pro uchování aktuálnímu a maximálnímu počtu protnutých polygonů.</p>
<p>Postupně projde všechny polygonu v poli a pokud je polygon začínající, přičte polygon k aktuálnímu počtu protnutých polygonů, pokud ne, tak ho odečte.<br>
Pokud je aktuální počet větší než maximální, nastaví maximální na aktuální.</p>
<p>Po tom, co projde všechny vrcholy vypíše uchované maximum.</p>
<h2 id="asymptotická-složitost">Asymptotická složitost</h2>
<p>Algoritmus se skládá ze tří částí:</p>
<ol>
<li>Počítání vzdálenosti vrcholů a určování začátku a konce každého polygonu. <code>O(n)</code></li>
<li>Seřazení pole vrcholů. <code>O(nlog(n))</code></li>
<li>Získání maxima protnutých polygonů. <code>O(n)</code></li>
</ol>
<p>Celkem <code>O(n + nlog(n) + n)</code>.</p>
<p>Tedy <code>O(nlog(n))</code> (nejpomalejší částí je řazení)</p>
</div>
</body>

</html>
